/* mbed Microcontroller Library
 * Copyright (c) 2019 ARM Limited
 * SPDX-License-Identifier: Apache-2.0
 */

#include "mbed.h"
/// Variable tapis///
DigitalOut Bob1(D2);
DigitalOut Bob2(D3);
DigitalOut Bob3(D4);
DigitalOut Bob4(D5);
DigitalOut EnaA(D7);
DigitalOut EnaB(D8);

/// Variable Servo_mot///
int attente_servomot_1=32000;
int attente_servomot_2=32000;
PwmOut servo_mot_1(D9);
PwmOut servo_mot_2(D10);
InterruptIn mybutton(PC_13); // Déclaration de l'interruption
//DigitalOut myled(LED1);

///Variable ComRS232///
DigitalOut led1(LED1);
UnbufferedSerial      my_pc(USBTX, USBRX);
char data;
void ISR_my_pc_reception(void);


////Appelle Fonction
void reglage_pins(int pin1, int pin2, int pin3, int pin4);
void prochainStep(int numero);
void marche_avant(float attente, int nombre_de_pas);
void marche_arriere(float attente, int nombre_de_pas);

void aller_retour_1();   
void aller_retour_2();

void ISR_my_pc_reception();
///MAIN///
int main()
{
          my_pc.baud(115200);
    my_pc.attach(&ISR_my_pc_reception, UnbufferedSerial::RxIrq);

    servo_mot_1.period_ms(20);         // Initialisation période
    servo_mot_1.pulsewidth_us(1500);  

    servo_mot_2.period_ms(20);         // Initialisation période
    servo_mot_2.pulsewidth_us(1500);  

               
    while(1) {
        EnaA.write(1);
        EnaB.write(1);
// 200 pas en marche avant, rotation rapide
   //     marche_avant(10000, 200);
   //     wait_us(0.01);
// 20 pas en marche arrière rotation lente
        marche_arriere(5000, 200);
        wait_us(0.05);
    }
}

// fonction tapis roulant
void reglage_pins(int pin1, int pin2, int pin3, int pin4)
{
    Bob1 = pin1;
    Bob2 = pin2;
    Bob3 = pin3;
    Bob4 = pin4;
}

void prochainStep(int numero)
{
    if (numero == 0) {
        reglage_pins(1, 0, 0, 0);
    }
    if (numero == 1) {
        reglage_pins(0, 1, 0, 0);
    }
    if (numero == 2) {
        reglage_pins(0, 0, 1, 0);
    }
    if (numero == 3) {
        reglage_pins(0, 0, 0, 1);
    }
}
void marche_avant(float attente, int nombre_de_pas)
{
    for (int i=0; i <= nombre_de_pas; i++) {
        prochainStep(i % 4);
        wait_us(attente);
    }
}

void marche_arriere(float attente, int nombre_de_pas)
{
    for (int i=0; i <= nombre_de_pas; i++) {
        prochainStep(3 - (i % 4));
        wait_us(attente);
    }
}

//Fonction servo_mot

void aller_retour_1(){
 servo_mot_1.pulsewidth_us(2500);   // Angle négatif
        wait_us(500000);
        servo_mot_1.pulsewidth_us(600);   // Angle positif
        wait_us(500000);

}
void aller_retour_2(){
 servo_mot_2.pulsewidth_us(2500);   // Angle négatif
        wait_us(500000);
        servo_mot_2.pulsewidth_us(600);   // Angle positif
        wait_us(500000);

}


void ISR_my_pc_reception(){
    my_pc.read(&data, 1);     // get the received byte
    my_pc.write(&data, 1);///Si on le met après python doit attendre l'action du servomoteur
    if(data == 'a'){  
        wait_us(attente_servomot_1);
        aller_retour_1();
          
         led1=1; } // association de l'interruption 1 a un front descendant sur l'entree USER_BUTTON
   /* if(data == 'e'){
        released();
        led1=0;}*/
            
    else if(data == 'b'){
        wait_us(attente_servomot_2);
        aller_retour_2();
    }
    my_pc.write(&data, 1);
}